-- Auto generated script file --

vanilla_model.PLAYER:setVisible(false) -- Hide vanilla models cuz they are wierd for 4-footed fob
vanilla_model.CAPE:setVisible(false) -- You can draw cape using blockbench and set this to true
vanilla_model.ELYTRA:setVisible(false) -- Please use the elytra drawn in blockbench
vanilla_model.ARMOR:setVisible(false) -- Don't set it to ture, or else you'll become very compacted with armor if you do wear any.
renderer:setRenderRightArm(false) -- Hide First Person Hand cuz it's weird

renderer:setOffsetCameraPivot(0,0,0)



-- To adjust the eye height and hitbox for your model, please do /scale set acoordingly using Pehkui
-- The mcfunction only adjust to the optimal stats for the fox avatar 

-- Registering some variables
-- Replace the stuff after "=" to your needs, in case you renamed some animations
-- Not recommended to touch the stuff before it, they will be called later
local tail_wag = animations.model.tail_wag -- Ambient Tail Wagging :3
local crouch = animations.model.crouch -- Crouch
local shake = animations.model.shake -- Shake water / snow
local sit = animations.model.sit -- Sit
local pounce = animations.model.pounce --Pounce
local close_wing = animations.model.close_wing -- Close wing when not fall flying
local sleep = animations.model.sleep -- Eepy
-- The below animations manually turn the avatar 90 degrees so it wont look wierd
local swim = animations.model.swim -- Swim
local unswim = animations.model.unswim -- Unswim Animation
local sleepBed = animations.model.sleep_bed -- Bed Eepy
local fall_flying = animations.model.fall_flying -- Fall Flying
local riptide = animations.model.riptide -- Riptide Spin
local stuck = animations.model.stuck -- stuck
local idle = animations.model.idle -- Idle Breathiign

-- The main script part, no touch if no know >:3
-- If you need more Origin-Figura cross connection for this fox origins, lemme know via Origins discord

-- man idk how lua works

-- Tail start wagging from the beginning :3
tail_wag:play()

-- Some functions --
function sleepAnimation()
    closeEyes()
    sit:stop()
    tail_wag:stop()
    sleep:play()
end

function unsleepAnimation()
    openEyes()
    sleep:stop()
    sleepBed:stop()
    tail_wag:restart()
end

function sleepBedAnimation()
    closeEyes()
    sit:stop()
    tail_wag:stop()
    sleepBed:play()
end

function resetWing()
    if not (player:getPose() == "FALL_FLYING" or
            sit:isPlaying() or
            sleep:isPlaying() or
            sleepBed:isPlaying() or
            shake:isPlaying() or
            pounce:isPlaying() or
            swim:isPlaying()
            ) then
                close_wing:play()
        else
            close_wing:stop()
        end
    end

-- Close eyes when eepy
-- Close eyes by shifting UV of the Textures up by 1 pixel :3
faceModel = models.model.root.Head.Eyes

-- Tail models address
tail = models.model.root.Tail

function closeEyes()
    faceModel:setUV(0,1/32)
end

function openEyes()
    faceModel:setUV(0,0)
end

-- A mysterious function inspired by Splat from Discord
function getPower(t)
    temp = 0

    for _,_,_ in pairs(t) do
        temp = temp + 1
    end
    return temp
end

local tailSpeed
local pouncing = 0
local is_shaking = 0

local currentRot = 0 
local rotDeg = 0

local karma_p = 0
local karma_n = 0
local karma = 0
local lock_karmic = 1

local userTailCount = 9
local displayedTailCount = 1

-- Ticking functions
function events.tick()
    local powerList
    local originList
    local isFabric
    if player:getNbt()["cardinal_components"] then
        powerList = player:getNbt()["cardinal_components"]["apoli:powers"]["Powers"]
        isFabric = true
    else
        powerList = player:getNbt()["ForgeCaps"]["apoli:powers"]["Powers"]
        isFabric = false
    end

    -- Retrieve the number of powers the player has
    getPower(powerList)
    -- Good to have isLoaded() in front of everything
    if player:isLoaded() then

        -- Speed up Tail wag :3

        if player:isSprinting() then
            tailSpeed = 7
        elseif player:getVelocity():length() > 0 then
            if player:getPose() == "FALL_FLYING" or player:getPose() == "CROUCHING" or crouch:isPlaying() then
                tailSpeed = 1
            else
                tailSpeed = 5
            end
        else
            tailSpeed = 1
        end



        -- Swim Pose (Rotated by 90)
        if player:getPose() == "SWIMMING" then
            unswim:stop()
            swim:play()
            elseif swim:isPlaying() then
                unswim:play()
                swim:stop()
        end

        -- Elytra Flight (Rotated by 90)
        if player:getPose() == "FALL_FLYING" then
            pounce:stop()
        end

        -- Unsit and Unsleep
        if player:getVelocity():length() > 0 then
            sit:stop()
            if sleepBed:isPlaying() and player:getNbt()["SleepTimer"] == 0 then
                unsleepAnimation()
            end
        end

        -- Sleep Animation but Tuned to Bed (Rotated by 90)
        -- This Does not work if you go bed while falling
        if player:getPose() == "SLEEPING" then
            if sleep:isPlaying() then
                unsleepAnimation()
            end
            sleepBedAnimation()
        end

        -- CloseWing play or stop under various conditions
        resetWing()

        for index = 1, temp do
            -- This resource is for shaking, specifically created for this script to detect
            if powerList[index]["Type"] == "thorigins:fox/thfluffy_is_shaking" then
                if isFabric then
                    is_shaking = powerList[index]["Data"]
                else
                    is_shaking = powerList[index]["Data"].Value
                end

            -- This resource is for tracking [Sleepin Mode] [0, 1200]
            elseif powerList[index]["Type"] == "thorigins:fox/thfoxify_afk_timer" then
                if isFabric then
                    afk_timer = powerList[index]["Data"]
                else
                    afk_timer = powerList[index]["Data"].Value
                end
            -- This resource is for pouncing [0 / 1]
            elseif powerList[index]["Type"] == "thorigins:fox/thdash_left_ground" or powerList[index]["Type"] == "thorigins:kitsune/thdash2_left_ground" or powerList[index]["Type"] == "thorigins:ninetails/thdash3_left_ground" then
                if isFabric then
                    pouncing = powerList[index]["Data"]
                else
                    pouncing = powerList[index]["Data"].Value
                end

            -- Check Karma
            elseif powerList[index]["Type"] == "thorigins:thkarma_karma_n" then
                if isFabric then
                    karma_n = powerList[index]["Data"]
                else
                    karma_n = powerList[index]["Data"].Value
                end
            elseif powerList[index]["Type"] == "thorigins:thkarma_karma_p" then 
                if isFabric then
                    karma_p = powerList[index]["Data"]
                else
                    karma_p = powerList[index]["Data"].Value
                end
            if lock_karmic then
                karma = math.max(karma_p, karma_n)
            else
                karma = 2000
            end

            local lock_kitsune
            local lock_ninetails
            elseif powerList[index]["Type"] == "thorigins:thtransform_lock_kitsune" then 
                if isFabric then
                    lock_kitsune = powerList[index]["Data"]
                else
                    lock_kitsune = powerList[index]["Data"].Value
                end
            elseif powerList[index]["Type"] == "thorigins:thtransform_lock_ninetails" then
                if isFabric then
                    lock_ninetails = powerList[index]["Data"]
                else
                    lock_ninetails = powerList[index]["Data"].Value
                end
            end

            lock_karmic = lock_kitsune == 1 and lock_ninetails == 1
        end

        -- The below animations actively read Origin resources through player NBT
        -- Ignore this part if you are not using the Fox Origin
        -- Shake
        if is_shaking == 1 then
            shake:play()
            sit:stop()
            sleep:stop()
        else
            shake:stop()
        end

        if afk_timer then
            if afk_timer == 0 and player:getPose() == "STANDING" and not sit:isPlaying() then
                sleepAnimation()
            elseif afk_timer > 1195 and tail_wag:isStopped() then
                unsleepAnimation()
            end
        end
    end
    displayedTailCount = math.min(userTailCount, math.floor(karma/250 + 1))
end

function events.render()
    
    if player:isLoaded() then
        -- Idle Breathig Animation
        idle:setPlaying(player:getNbt()["Air"] == 300)
        -- Crouching
        crouch:setPlaying(player:getPose() == "CROUCHING")

        -- Below animations only rotate by 90 dg
        -- Elytra
        fall_flying:setPlaying(player:getPose() == "FALL_FLYING")
        -- Riptide
        riptide:setPlaying(player:getPose() == "SPIN_ATTACK")
    end

    pawOnBlock = world.getBlockState(player:getPos():sub(0, 0.1, 0)):getID()

    tail_wag:setSpeed(tailSpeed)
    if pouncing == 1 then
        if player:getNbt()["OnGround"] == 0 then

            -- TRIGONOMETRY HELL YEAHAHAHAA
            rotDeg = math.deg(math.atan2(player:getVelocity().y, math.sqrt(player:getVelocity().x ^ 2  + player:getVelocity().z ^ 2)))
            rotDeg = math.clamp(rotDeg, -110, 70)

            -- You going upwards is instant
            if models:getRot().x < rotDeg then
                currentRot = rotDeg
            else
                -- But falling down isn't
                currentRot = models:getRot().x
            end
            -- random lerp function I found in Figura wiki. Why not
            currentRot = math.lerp(currentRot, rotDeg, 0.25)
            
            -- Fall Flying stop anime
            if not fall_flying:isPlaying() then
                pounce:play()
                tail_wag:stop()
            end
        end
    -- Landed after pouncing
    elseif pounce:isPlaying() then
        pounce:stop()
        -- Stuck Animation Triggering: 
        -- 1. Velocity Magnitude <= 0.08 (So you won't see this animation played while you are actually going forward)
        -- 2. Player is looking roughly straightdown (For realistic reason: Head sunk into snow :3)
        -- 3. The block directly below is Snow / SnowBlock / PowderSnow
        if player:getVelocity():length() <= 0.08 and player:getRot().x >= 70 and (pawOnBlock == "minecraft:snow" or pawOnBlock == "minecraft:snow_block" or pawOnBlock == "minecraft:powder_snow") then
            stuck:play()
        end
    else
        -- Reset CurrentRotation in Normal occasions
        currentRot = 0
    end

    -- Also Fall Flying reset CurrentRotatoin
    if player:getPose() == "FALL_FLYING" then
        currentRot = 0
    end

    -- Set Model Rotation based on Current Rotation
    -- Give Head free rotation by counter it to -ve
    models:setRot(currentRot, 0, 0)
    models.model.root.Head:setRot(-currentRot, 0, 0)

    -- If you moved, stop stuck animation
    if player:getVelocity():length() > 0.08 and stuck:isPlaying() then
        stuck:stop()
    end

    -- Crouch animation sequence
    if crouch:isPlaying() then
        -- If you moved, while crouching, the animation goes on
        if player:getVelocity():length() > 0 then
            crouch:play()
        -- If the Offset is already modified, annd you are not moving while crouching, PAUSE the crouching animation
        elseif crouch:getOffset() == 0.5 then
            crouch:pause()
        end

        -- This is foor the first time you enter crouching
        -- The first 0.25s animation is the fox crouching downn, and the remaining animations are walk cycles
        if crouch:getTime() >= 0.25 then
            -- So set the loop offset to 0.5, to skip the crouching down part annd loop the walk cycle 
            crouch:setOffset(0.5)
        end
    end
    -- If you no longer crouching, reset the offset, so that the Crouching down animation can be triggered the next time
    if crouch:isStopped() then
        crouch:setOffset(0)
    end


    -- Tail Grows with Karma
    tail.Tail1:setVisible(displayedTailCount >= 0)
    tail.Tail2:setVisible(displayedTailCount >= 2)
    tail.Tail3:setVisible(displayedTailCount >= 3)
    tail.Tail4:setVisible(displayedTailCount >= 4)
    tail.Tail5:setVisible(displayedTailCount >= 5)
    tail.Tail6:setVisible(displayedTailCount >= 6)
    tail.Tail7:setVisible(displayedTailCount >= 7)
    tail.Tail8:setVisible(displayedTailCount >= 8)
    tail.Tail9:setVisible(displayedTailCount == 9)

    -- Tail Animations, but actually they are 1 frame long Rotation + Positionn of different Tail Combinations -- I think my n key is brokenn hold on -- n n n n n n n nn n n nn n n n n n n  n n n n n n  n n  -- yep that checks out
    -- Also frees the rotation whenn stuck animation is playing
    animations.model.OneTail:setPlaying(displayedTailCount <= 1 and not (stuck:isPlaying() or sleep:isPlaying() or sleepBed:isPlaying()))
    animations.model.TwoTails:setPlaying(displayedTailCount == 2 and not (stuck:isPlaying() or sleep:isPlaying() or sleepBed:isPlaying()))
    animations.model.ThreeTails:setPlaying(displayedTailCount == 3 and not (stuck:isPlaying() or sleep:isPlaying() or sleepBed:isPlaying()))
    animations.model.FourTails:setPlaying(displayedTailCount == 4 and not (stuck:isPlaying() or sleep:isPlaying() or sleepBed:isPlaying()))
    animations.model.FiveTails:setPlaying(displayedTailCount == 5 and not (stuck:isPlaying() or sleep:isPlaying() or sleepBed:isPlaying()))
    animations.model.SixTails:setPlaying(displayedTailCount == 6 and not (stuck:isPlaying() or sleep:isPlaying() or sleepBed:isPlaying()))
    animations.model.SevenTails:setPlaying(displayedTailCount == 7 and not (stuck:isPlaying() or sleep:isPlaying() or sleepBed:isPlaying()))
    animations.model.EightTails:setPlaying(displayedTailCount == 8 and not (stuck:isPlaying() or sleep:isPlaying() or sleepBed:isPlaying()))
    animations.model.NineTails:setPlaying(displayedTailCount == 9 and not (stuck:isPlaying() or sleep:isPlaying() or sleepBed:isPlaying()))

    -- Set tail scale to grow
    -- idk why I did this but okay
    tail.Tail1:setScale(1, 1, 1.0 + displayedTailCount * 0.05)
    tail.Tail2:setScale(1, 1, 1.0 + displayedTailCount * 0.05)
    tail.Tail3:setScale(1, 1, 1.0 + displayedTailCount * 0.05)
    tail.Tail4:setScale(1, 1, 1.0 + displayedTailCount * 0.05)
    tail.Tail5:setScale(1, 1, 1.0 + displayedTailCount * 0.05)
    tail.Tail6:setScale(1, 1, 1.0 + displayedTailCount * 0.05)
    tail.Tail7:setScale(1, 1, 1.0 + displayedTailCount * 0.05)
    tail.Tail8:setScale(1, 1, 1.0 + displayedTailCount * 0.05)
    tail.Tail9:setScale(1, 1, 1.0 + displayedTailCount * 0.05)
end

-- Action Wheel
local emotes = action_wheel:newPage()
action_wheel:setPage(emotes)

-- Sleep Emote
local action = emotes:newAction()
    :title("Sleep")
    :item("minecraft:red_bed")
    :hoverColor(1,0,1)
    :onLeftClick(
        function()
            sleepAnimation()
        end
    )

-- Sit Emote
local action = emotes:newAction()
    :title("Sit")
    :item("minecraft:scaffolding")
    :hoverColor(1,0,1)
    :onLeftClick(
        function()
            sleep:stop()
            sit:play()
        end
    )

-- Tail Manipulation
local action = emotes:newAction()
    :title("Hide / Unhide excessive Tails\n(LeftClick [-] / RightClick [+])")
    :item("minecraft:feather")
    :hoverColor(1,0,1)
    :onRightClick(
        function()
            userTailCount = math.clamp(userTailCount + 1, 1, 9)
            print("[Tails Display Setting]\nTails Available:",math.floor(karma/250 + 1), "\nTails Displayed:", userTailCount, "\n")
        end
    )
    :onLeftClick(
        function()
            userTailCount = math.clamp(userTailCount - 1, 1, 9)
            print("[Tails Display Setting]\nTails Available:",math.floor(karma/250 + 1), "\nTails Displayed:", userTailCount, "\n")
        end
    )